/* balbak.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int balbak_(nm, n, low, igh, scale, m, z__)
integer *nm, *n, *low, *igh;
doublereal *scale;
integer *m;
doublereal *z__;
{
    /* System generated locals */
    integer z_dim1, z_offset, i__1, i__2;

    /* Local variables */
    static integer i__, j, k;
    static doublereal s;
    static integer ii;

/* ***BEGIN PROLOGUE  BALBAK */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C4 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Forms eigenvectors of DOUBLE PRECISION general matrix from */
/*            eigenvectors of matrix output from BALANC. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure BALBAK, */
/*     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch. */
/*     HANDBOOK FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971). */

/*     This subroutine forms the eigenvectors of a DOUBLE PRECISION GENERAL */
/*     matrix by back transforming those of the corresponding */
/*     balanced matrix determined by  BALANC. */

/*     On INPUT */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        LOW and IGH are integers determined by  BALANC. */

/*        SCALE contains information determining the permutations */
/*          and scaling factors used by  BALANC. */

/*        M is the number of columns of Z to be back transformed. */

/*        Z contains the DOUBLE PRECISION and imaginary parts of the eigen- */
/*          vectors to be back transformed in its first M columns. */

/*     On OUTPUT */

/*        Z contains the DOUBLE PRECISION and imaginary parts of the */
/*          transformed eigenvectors in its first M columns. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  BALBAK */


/* ***FIRST EXECUTABLE STATEMENT  BALBAK */
    /* Parameter adjustments */
    --scale;
    z_dim1 = *nm;
    z_offset = z_dim1 + 1;
    z__ -= z_offset;

    /* Function Body */
    if (*m == 0) {
	goto L200;
    }
    if (*igh == *low) {
	goto L120;
    }

    i__1 = *igh;
    for (i__ = *low; i__ <= i__1; ++i__) {
	s = scale[i__];
/*     .......... LEFT HAND EIGENVECTORS ARE BACK TRANSFORMED */
/*                IF THE FOREGOING STATEMENT IS REPLACED BY */
/*                S=1.0E0/SCALE(I). .......... */
	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
/* L100: */
	    z__[i__ + j * z_dim1] *= s;
	}

/* L110: */
    }
/*     ......... FOR I=LOW-1 STEP -1 UNTIL 1, */
/*               IGH+1 STEP 1 UNTIL N DO -- .......... */
L120:
    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
	i__ = ii;
	if (i__ >= *low && i__ <= *igh) {
	    goto L140;
	}
	if (i__ < *low) {
	    i__ = *low - ii;
	}
	k = (integer) scale[i__];
	if (k == i__) {
	    goto L140;
	}

	i__2 = *m;
	for (j = 1; j <= i__2; ++j) {
	    s = z__[i__ + j * z_dim1];
	    z__[i__ + j * z_dim1] = z__[k + j * z_dim1];
	    z__[k + j * z_dim1] = s;
/* L130: */
	}

L140:
	;
    }

L200:
    return 0;
} /* balbak_ */

