/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*
 *       msample.h:  header file for the Msample/ library                     *
 *                -  included by Msample/ (meiosis sampling) functions        *
 *                   and by main programs calling Msample/ functions          *
 *         Msample library combined with Lsample library: EAT June 2002       *
 *            many Msample routines moved to new Markers library              *
 *::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef MSAMPLE_H
#define MSAMPLE_H

/**
 * @addtogroup sample
 * @{
 */

#include "incs.h"
#include "nghds.h"
#include "markers.h"
#include "rans.h"

struct gp_rfunc {
        struct gp_rfunc *next;
        int *inv;
        double *p;
        int n_inv,nc,flag;
};

struct gp_rfunc_ptr {
        struct gp_rfunc_ptr *next;
        struct gp_rfunc *rf;
};

struct gp_rfnode {
        struct gp_rfnode *next;
        struct gp_rfunc *rf;
        int y;
};

struct deg_list {
        struct deg_list *next,*prev,*abs_list;
        int deg,gene;
};


/* Maximum number of genes in an RFunction for gen_pen()
 * Note that memory and patience will run out long before this does...       */

#define MAX_GP_RF_GENES 64

void  gene_update (int, int, int);
void  fwd_compute (int, double, double *, double *, double *);
int   back_sample (int, int, int, double, double);
int   set_genes (int);
void  realise (int, double ***, int);
void  trait_segs (int);
void  next_marker_segs (int, int, int, int);
void  set_genotypes (int, int, double *, int *, int *);
void  free_allocate_loci (void);
void  do_msmpl (int, int, int, int, double **, int ***, int);
void  alloc_msmpl (void),             free_msmpl (void);

void  full_seg_prob (int, int, int ***, double **);
double diff_seg_prob (int, int, int, int *, double **);
double lik_rat (int, int, int, int);
double full_pen_seg_lod (int, int, int, int, int ***);

/* following appear to be obsolete: EAT June 2002   */
/* void  print_segs (int);
 * double new_pen (int, int *[2], int ***, double *, int, int, int *);
 * double prob_data (int, int, int, int);
 */

/* ** new from Simon  06/20/01 ** */
double gen_pen(int,int *[2],int ***,double *,int,int,int *);
void alloc_gen_pen(int,int);
void free_gen_pen(void);
void alloc_seg_pen(int,int,int ***, double ***);
void free_seg_pen(int, double ***);
double seg_pen(int,int *[2],int ***,double *,int,int,int *);
double seg_pen2(int,int ***,double *,int,int,int *);

/* new sampling routine;  EAT Sep 2002 */

void sampling(int, int, int, int, int, int *, int *, int ***,  double **, int);

/** @} */

#endif
