/*************************************************************************
  
  program name: peelseq_set.c
  
  program to preprocess and set peeling sequence, so it is now read in
    once only, and is used by index, not by name.
  
  also modify peeling sequence notation, so that (in data file)
    pivots at end of pedigree are zero, but final pivots are -1, 
    so can accumulate probabilities over several pedigrees.
  
  EAT March 1997.
  
  The final 0/-1 pivots, are now processed to -1, -2 by this program, to
  avoid confusion with individuals of index 0   (EAT, May 1997)
  
**************************************************************************/

#include "nghds.h"
#include "peelie.h"

/**************************************************************************/

void  peelseq_set (char *peel_file)
{
   int   nch;
   int   end_peel;
   char  ma[MAXNAMLEN + 1];
   char  pa[MAXNAMLEN + 1];
   char  child[MAXNAMLEN + 1];
   char  pivot[MAXNAMLEN + 1];
   int   j, k;
   FILE *peel_seq;

   if (!(peel_seq = open_fil (PEEL)))
      give_up (ERR_qit);

   k = 0;
   end_peel = 0;

   while (!end_peel)
   {
      read_name (peel_seq, pa);
      read_name (peel_seq, ma);
      read_name (peel_seq, pivot);
      fscanf (peel_seq, "%d", &nch);
      if (strncmp (pivot, ENDPEEL, MAXNAMLEN) == 0)
         end_peel = 1;
      k = k + 4;
      for (j = 1; j <= nch; ++j)
      {
         read_name (peel_seq, child);
         ++k;
      }
   }
   fclose (peel_seq);

   peelseq = (int *) malloc ((k + 1) * sizeof (int));
   printf (" The peeling sequence file has been read:  %d entries\n\n", k);

   if (!(peel_seq = open_fil (PEEL)))
      give_up (ERR_qit);

   k = 0;
   end_peel = 0;
   while (!end_peel)
   {
      read_name (peel_seq, pa);
      read_name (peel_seq, ma);
      read_name (peel_seq, pivot);
      fscanf (peel_seq, "%d", &nch);
      peelseq[k] = get_posit (pa);
      peelseq[k + 1] = get_posit (ma);
      if (strncmp (pivot, ENDCMPT, MAXNAMLEN) == 0)
      {
         peelseq[k + 2] = -1;
      }
      else if (strncmp (pivot, ENDPEEL, MAXNAMLEN) == 0)
      {
         peelseq[k + 2] = -2;
         end_peel = 1;
      }
      else
      {
         peelseq[k + 2] = get_posit (pivot);
      }

      peelseq[k + 3] = nch;
      k = k + 4;
      for (j = 1; j <= nch; ++j)
      {
         read_name (peel_seq, child);
         peelseq[k] = get_posit (child);
         ++k;
      }
   }
   fclose (peel_seq);
}
