/*
 * Call to Fortran LINPACK routines to get inverses 
 * of a general G -- in general non-symmetric, after reduction 
 */

#include "quant.h"

double invert_mat (double **mat, int nn)
/* mat is the matrix,  nn the dimension   */
{
   int   i, j, job;
   int  *ipvt;
   double cdet;
   double rcond, det[2];
   double *z, *work, *dummy;

   dummy = malloc (nn * nn * sizeof (double));
   alloc_chk (WHERE, dummy);

   for (i = 1; i <= nn; ++i)
      for (j = 1; j <= nn; ++j)
         dummy[i + nn * j - nn - 1] = mat[i][j];
   job = 11;

   /*
    * printf ("\n inside invert_mat and about to invert "); 
    * for (i=0; i< nn*nn; ++i)
    *     printf ("\ %f", dummy[i] ); 
    * fflush(stdout);     
    */

   ipvt = malloc (nn * sizeof (int));
   alloc_chk (WHERE, ipvt);
   z = malloc (nn * sizeof (double));
   alloc_chk (WHERE, z);

   dgeco_ (dummy, &nn, &nn, ipvt, &rcond, z);

   work = z;

   dgedi_ (dummy, &nn, &nn, ipvt, det, work, &job);

   free ((void *) work);
   z = work = NULL;
   free ((void *) ipvt);
   ipvt = NULL;

   cdet = log (det[0]) + det[1] * log (10.0);

   for (i = 1; i <= nn; ++i)
      for (j = 1; j <= nn; ++j)
         mat[i][j] = dummy[i + nn * j - nn - 1];

   free ((void *) dummy);
   dummy = NULL;

   return (cdet);
}
